package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DokumenInternalService;
import com.jasamedika.medifirst2000.vo.DokumenInternalVO;
import com.jasamedika.medifirst2000.vo.SuratMasukInternalVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.Collection;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/dokumen-internal")
public class DokumenInternalController extends LocaleController<DokumenInternalVO> {

	private static final Logger LOGGER = getLogger(DokumenInternalController.class);

	@Autowired
	private DokumenInternalService dokumenInternalService;

	@RequestMapping(value = "/save-dokumen-internal/", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> addVO(@Valid @RequestBody SuratMasukInternalVO vo,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = dokumenInternalService.addSuratMasukInternal(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when addSuratMasukInternal", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when addSuratMasukInternal", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/set-distribusi-dokumen/", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> setDistribusi(@Valid @RequestBody SuratMasukInternalVO vo,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = dokumenInternalService.setDistribusiKirimSuratInternalEksternal(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when setDistribusiKirimSuratInternalEksternal", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when setDistribusiKirimSuratInternalEksternal", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-dokumen")
	@ResponseBody
	public ResponseEntity<Collection<DokumenInternalVO>> findDokumenInternalByTanggalAndNama(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "10") Integer limit,
			@RequestParam(value = "sort", required = false, defaultValue = "noRec") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@RequestParam(value = "dateStart", required = false) String dateStart,
			@RequestParam(value = "dateEnd", required = false) String dateEnd,
			@RequestParam(value = "noKirim", required = false) String noKirim) {
		Map<String, Object> resultPageMap = dokumenInternalService.dokumenInternalPaging(page, limit, sort, dir,
				dateStart, dateEnd, noKirim);
		return constructListPageResult(resultPageMap);
	}

	@RequestMapping(value = "/get-dokumen-by-norec/", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<DokumenInternalVO> findByNoRec(@RequestParam(value = "noRec") String noRec) {
		DokumenInternalVO vo = dokumenInternalService.findByNoRec(noRec);
		try {
			return getJsonResponse(vo, OK, mapHeaderMessage);
		} catch (IllegalArgumentException e) {
			throw new ServiceVOException(e.getMessage());
		}
	}

}
